import { TestBed } from '@angular/core/testing';

import { TokenService } from '@app/_services/token.service';
import {Token} from '@app/_models';

describe('TokenService', () => {
  let service: TokenService;

  beforeEach(() => {
    TestBed.configureTestingModule({});
    service = TestBed.inject(TokenService);
  });

  it('should be created', () => {
    expect(service).toBeTruthy();
  });

  it('should return token for available token', () => {
    const token: Token = {
      name: 'Giftable Reserve',
      symbol: 'GRZ',
      address: '0xa686005CE37Dce7738436256982C3903f2E4ea8E',
      supply: '1000000001000000000000000000',
      decimals: '18',
      reserves: {},
    };
    service.addToken(token);
    service.getTokenBySymbol('GRZ').then(tokenSubject => {
      tokenSubject.subscribe(returnedToken => {
        expect(returnedToken).toEqual(token);
      });
    });
  });

  it('should not return token for unavailable token', () => {
    service.getTokenBySymbol('ABC').then(tokenSubject => {
      tokenSubject.subscribe(returnedToken => {
        expect(returnedToken).toBeUndefined();
      });
    });
  });
});
